Typescript React Window Component

This tutorial will show you the basics of how to get started with the jQWidgets Window React Component.

Prerequisites

Refer to Getting Started with React before you start with this help topic.

Structure


I. Imports:

import * as React from 'react';
import 'jqwidgets-scripts/jqwidgets/styles/jqx.base.css';
import 'jqwidgets-scripts/jqwidgets/styles/jqx.material-purple.css';
import JqxWindow, { IWindowProps } from 'jqwidgets-scripts/jqwidgets-react-tsx/jqxwindow';

II. Class:

class App extends React.PureComponent<{}, IWindowProps> {
constructor(props: {}) {
super(props);
this.state = {
width: '100%'
// Other Widget Props
}
}
render() {
return (
<JqxWindow
width={this.state.width} height={"100%"} .....
/>
)
}
}

III. Render:

Events

The event names in React are constructed of the original event names starting with capital letter plus on upfront:

Methods & Properties

This is how you call methods & props:

Every component have a method setOptions which accepts a object as an argument. This object contains component settings.

Every component also have a method getOptions which returns the value of the requested option.

Window API

API Reference of the jQWidgets Window React Component: Window API

Window Demos

Demos Reference of the jQwidgets Window React Component: Window Demos

jQWidgets
  • Facebook
  • Twitter
  • Demo
  • Download
  • Documentation
  • License and Pricing
  • Services
  • Forums
  • About
  • Terms of Use
  • Privacy Policy
  • Contact Us

jQWidgets © 2011-2025. All Rights Reserved.

Vue UI Components Documentation
Vue Window Component
The Window component for Vue directs a user's attention to a particular activity in your application, such as entering data or viewing information. Consider using a jQWidgets Window when you want greater customization, you want to block the user interface outside the window, or when you want to retrieve a DialogResult and other data from the popup window. jQWidgets Window can be displayed as a modal dialog window that blocks user interaction with the underlying user interface or as a standard window without blocking the web page's user interface.
Prerequisites
Refer to Vue Getting Started before you start with this help topic.
Configuration
After you have created your App.vue file, here is how you should structure it:
The Window component for Vue requires the following import:
import jqxWindow from "jqwidgets-scripts/jqwidgets-vue/vue_jqxwindow.vue";
Add the jqxWindow component to the components section of the the Vue class:
components: { JqxWindow },
Template
The App.vue has a <template>
structural tag where we determine the application structure.
There we will also set the tags for the new components - <JqxWindow/>
<template> <JqxWindow :width="width" :height="height"> <div> Header </div> <div> Content </div> </JqxWindow></template>
Properties
The properties of the <JqxWindow/> component are defined in the data
member of the Vue class.
We should put them in the return object of the data function:
Events
The events in Vue are set as an attribute with @ prefix, for example:
<JqxWindow @open="onOpen()" :width="width" :height="height"> <div> Header </div> <div> Content </div></JqxWindow>
All events that are bound to a component are implemented in the methods
member of the Vue class.
Methods
To use a component's method we should have its reference. In Vue we refer to a component by the special $refs
property.
Before that we need to add the desired name reference to that component:
<JqxWindow ref="window"></JqxWindow>
Here how you can use a component's method:
this.$refs.window.setTitle('New Title');
If we want to add additional methods we should also implement them in the methods
member.
In case we need to do some precalculation or something else before the components are rendered, we should use the beforeCreate
member.
It depends on the case.
If you have followed the above steps, you App.vue file would look like this:
App.vue:
<template> <JqxWindow ref="window" @open="onOpen()" :width="width" :height="height"> <div> Header </div> <div> Content </div> </JqxWindow></template> <script> // Import the components that will be used import JqxWindow from "jqwidgets-scripts/jqwidgets-vue/vue_jqxwindow.vue"; export default { components: { // Adding imported widgets here JqxWindow }, data: function () { // Define properties which will use in the widget return { width: 270, height: 155 } }, beforeCreate: function () { // Add here any data where you want to transform before components be rendered }, methods: { // Add here all used callbacks and/or events onOpen: function () { // Do something... this.$refs.window.setTitle('New Title'); } } }</script> <style></style>
Window Example
<template> <div> <JqxButton @click="showWindowButtonClick()" :width="80" style="float: left;"> Open </JqxButton> <JqxButton @click="hideWindowButtonClick()" :width="100" style="float: left; margin-left: 3px;"> Close </JqxButton> <JqxButton @click="pinWindowButtonClick()" :width="80" style="float: left; margin-left: 3px;"> Pin </JqxButton> <JqxButton @click="unpinWindowButtonClick()" :width="80" style="float: left; margin-left: 5px;"> Unpin </JqxButton> <JqxButton @click="collapseWindowButtonClick()" :width="80" style="float: left; margin-left: 3px;"> Collapse </JqxButton> <JqxButton @click="expandWindowButtonClick()" :width="80" style="float: left; margin-left: 3px;"> Expand </JqxButton> <JqxWindow ref="customWindow" :width="400" :height="115" :position="{ x: 50, y: 120 }" :cancelButton="'#cancelButton'" :initContent="init" :resizable="false"> <div>Find</div> <div> <div id="customWindowContent" style="overflow: hidden;"> <div style="margin: 10px;"> Fi<u>n</u>d what: <input ref="searchTextInput" @keyup="onKey($event)" @keydown="onKeyUp($event)" @change="onChange($event)" type='text' style="margin-left: 5px; height: 17px; width: 175px; border: 1px solid #aaa;" /> <div style="float: right"> <input type="button" value="Find Next" style="margin-bottom: 5px;" id="searchTextButton" /><br /> <input type="button" value="Cancel" id="cancelButton" /> </div> <br /> <br /> <JqxCheckbox ref="checkBox" :width="150">Match case</JqxCheckbox> </div> </div> </div> </JqxWindow> </div></template><script> import JqxWindow from 'jqwidgets-scripts/jqwidgets-vue/vue_jqxwindow.vue'; import JqxButton from 'jqwidgets-scripts/jqwidgets-vue/vue_jqxbuttons.vue'; import JqxCheckbox from 'jqwidgets-scripts/jqwidgets-vue/vue_jqxcheckbox.vue'; export default { components: { JqxWindow, JqxButton, JqxCheckbox }, beforeCreate: function () { this.searchTextButton = null; }, methods: { init: function () { this.searchTextButton = new jqxButton('#searchTextButton', { width: '80px', disabled: true }); new jqxButton('#cancelButton', { width: '80px', disabled: false }); }, searchButtonHandle: function () { if (this.$refs.searchTextInput !== null) { if (this.$refs.searchTextInput.value !== '') { this.searchTextButton.disabled = false; } else { this.searchTextButton.disabled = true; } } }, onKey: function (event) { this.searchButtonHandle(); }, onKeyUp: function (event) { this.searchButtonHandle(); }, onChange: function (event) { this.searchButtonHandle(); }, showWindowButtonClick: function () { this.$refs.customWindow.open(); }, hideWindowButtonClick: function () { this.$refs.customWindow.close(); }, pinWindowButtonClick: function () { this.$refs.customWindow.draggable = false; }, unpinWindowButtonClick: function () { this.$refs.customWindow.draggable = true; }, collapseWindowButtonClick: function () { this.$refs.customWindow.collapse(); }, expandWindowButtonClick: function () { this.$refs.customWindow.expand(); } } }</script><style></style>

Angular Window Component

The Window component for Angular directs a user's attention to a particular activity in your application, such as entering data or viewing information. Consider using a jQWidgets Window when you want greater customization, you want to block the user interface outside the window, or when you want to retrieve a DialogResult and other data from the popup window. jQWidgets Window can be displayed as a modal dialog window that blocks user interaction with the underlying user interface or as a standard window without blocking the web page's user interface.

1. Installation

The easiest way to get started with jQWidgets UI for Angular is to use the Angular CLI Tool. To scaffold your project structure, follow its installation instructions.

npm install -g @angular/cli
ng new jqwidgets-project
cd jqwidgets-project

Install jQWidgets

jQWidgets Angular UI comes packaged with Angular CLI schematics to make creating Angular applications easier. Schematics are included with both @angular/cdk and jqwidgets-ng. Once you install the npm packages, they will be available through the Angular CLI.

Angular CLI supports the addition of packages through the ng add command. The ng add command provides faster and more user-friendly package installation. To install the jQWidgets UI for Angular package, use ng add and add the name of the NPM package:

ng add jqwidgets-ng

Alternatively, you can use the standard installation (Manual Setup)

jQWidgets UI for Angular is distributed as jqwidgets-ng NPM package

  1. Download and install the package.
    npm install jqwidgets-ng
  2. Adding CSS reference

    The following CSS file is available in ../node_modules/jqwidgets-ng/ package folder. This can be referenced in [src/styles.css] using following code.

    @import 'jqwidgets-ng/jqwidgets/styles/jqx.base.css';

    Another way to achieve the same is to edit the angular.json file and in the styles add the style.

    "styles": [
    	"node_modules/jqwidgets-ng/jqwidgets/styles/jqx.base.css"
    ]
    

2. Add the HTML for jQWidgets component in src/app/app.component.html

app.component.html


<div id="jqxWidget" #jqxWidget>
  <div style="float: left;">
    <div>
      <jqxButton [theme]="'fluent'" [width]="70" (onClick)="onShowButton()">Open</jqxButton>
      <jqxButton [theme]="'fluent'" [width]="70" (onClick)="onHideButton()">Close</jqxButton>
    </div>
    <div style="margin-top: 10px;">
      <jqxCheckBox [theme]="'fluent'" [width]="100" [checked]="true" (onChange)="onResizeCheckBox($event)">
        Resizable
      </jqxCheckBox>
      <jqxCheckBox [theme]="'fluent'" [width]="100" [checked]="true" (onChange)="onDragCheckBox($event)">
        Enable drag
      </jqxCheckBox>
    </div>
  </div>
  <div style="width: 100%; height: 650px; margin-top: 50px;" id="mainDemoContainer">
    <jqxWindow [theme]="'fluent'" #windowReference [width]="500" [height]="300"
               [maxHeight]="400" [minHeight]="200" [maxWidth]="700" [minWidth]="200"
               [showCollapseButton]="true">
      <div #windowHeader>
        <span>
          <img src="https://www.jqwidgets.com/angular/images/movie.png" alt="" style="margin-right: 15px" />Movies
        </span>
      </div>
      <div style="overflow: hidden;" #windowContent>
        <jqxTabs [theme]="'fluent'" [width]="'100%'" [height]="'100%'">
          <ul style="margin-left: 30px;">
            <li>Avatar</li>
            <li>End Game</li>
            <li>Twilight</li>
            <li>Unstoppable</li>
            <li>Priest</li>
          </ul>
          <div>
            <img src="https://www.jqwidgets.com/angular/images/avatar.png" style="float: left; margin: 10px;" alt="" />
            Avatar is a 2009 American[6][7] epic science fiction film written and directed by
            James Cameron, and starring Sam Worthington, Zoe Saldana, Stephen Lang, Michelle
            Rodriguez, Joel David Moore, Giovanni Ribisi and Sigourney Weaver. The film is set
            in the mid-22nd century, when humans are mining a precious mineral called unobtanium
            on Pandora , a lush habitable moon of a gas giant in the Alpha Centauri star system.
            The expansion of the mining colony threatens the continued existence of a local
            tribe of Na'vi—a humanoid species indigenous to Pandora. The film's title refers
            to the genetically engineered Na'vi-human hybrid bodies used by a team of researchers
            to interact with the natives of Pandora.
          </div>   <div>
            <img src="https://www.jqwidgets.com/angular/images/endgame.png" style="float: left; margin: 10px;" alt="" />
            End Game is a 2006 action/thriller film, written and directed by Andy Cheng. The
            film stars Cuba Gooding, Jr. as Secret Service agent Alex Thomas, who is shot in
            the hand, while unsuccessfully trying to protect the President (played by Jack Scalia)
            from an assassin's bullet. Later, with the help of a persistent newspaper reporter
            named Kate Crawford (played by Angie Harmon), he uncovers a vast conspiracy behind
            what initially appeared to be a lone gunman. James Woods, Burt Reynolds, and Anne
            Archer co–star in this film that was originally set to be shown in cinemas by MGM
            in 2005, but was delayed by the takeover from Sony and eventually sent direct to
            DVD.
          </div>
          <div>
            <img src="https://www.jqwidgets.com/angular/images/twilight.png" style="float: left; margin: 10px;" alt="" />
            The project was in development for approximately three years at Paramount Pictures,
            during which time a screen adaptation that differed significantly from the novel
            was written. Summit Entertainment acquired the rights to the novel after three years
            of the project's stagnant development. Melissa Rosenberg wrote a new adaptation
            of the novel shortly before the 2007–2008 Writers Guild of America strike and sought
            to be faithful to the novel's storyline. Principal photography took 44 days, and
            completed on May 2, 2008; the film was primarily shot in Oregon
          </div>
          <div>
            <img src="https://www.jqwidgets.com/angular/images/unstoppable.png" style="float: left; margin: 10px;" alt="" />
            Meanwhile, in a rail yard within the northern town of Fuller, two AWVR hostlers,
            Dewey (Ethan Suplee) and Gilleece (T.J. Miller), are ordered by Fuller operations
            dispatcher Bunny (Kevin Chapman) to move a freight train led by locomotive #777
            (nicknamed "Triple Seven") off its current track to clear the track for an excursion
            train carrying schoolchildren. Dewey attempts to take shortcuts, instructing Gilleece
            to leave the hoses for the air brakes disconnected for the short trip. Dewey later
            leaves the moving cab to throw a misaligned rail switch along the train's path,
            but is unable to climb back on, as the train's throttle jumps from idle, to full
            power. He is forced to report the train as a "coaster" to Fuller yardmaster Connie
            Hooper (Rosario Dawson)...
          </div>
          <div>
            <img src="https://www.jqwidgets.com/angular/images/priest.png" style="float: left; margin: 10px;" alt="" />
            Priest is a 2011 American post-apocalyptic sci-fi western and supernatural action
            film starring Paul Bettany as the title character. The film, directed by Scott Stewart,
            is based on the Korean comic of the same name. In an alternate world, humanity and
            vampires have warred for centuries. After the last Vampire War, the veteran Warrior
            Priest (Bettany) lives in obscurity with other humans inside one of the Church's
            walled cities. When the Priest's niece (Lily Collins) is kidnapped by vampires,
            the Priest breaks his vows to hunt them down. He is accompanied by the niece's boyfriend
            (Cam Gigandet), who is a wasteland sheriff, and a former Warrior Priestess (Maggie
            Q).
          </div>
        </jqxTabs>
      </div>
    </jqxWindow>
  </div>
</div>	

3. Setup Component Logic

app.component.ts


import { Component, ViewChild, AfterViewInit, OnInit, ElementRef } from '@angular/core';
import { jqxWindowModule, jqxWindowComponent } from 'jqwidgets-ng/jqxwindow';
import { jqxCheckBoxComponent, jqxCheckBoxModule } from 'jqwidgets-ng/jqxcheckbox';
import { jqxButtonComponent, jqxButtonModule } from 'jqwidgets-ng/jqxbuttons';
import { jqxTabsComponent, jqxTabsModule } from 'jqwidgets-ng/jqxtabs';

@Component({
    selector: 'app-root',
    imports: [jqxWindowModule, jqxTabsModule, jqxButtonModule, jqxCheckBoxModule],
    standalone: true,
    templateUrl: './app.component.html'
})

export class AppComponent {
    @ViewChild('windowReference') window: jqxWindowComponent;
    @ViewChild('jqxWidget') jqxWidget: ElementRef;

    ngAfterViewInit(): void {
        let offsetLeft = this.jqxWidget.nativeElement.offsetLeft;
        let offsetTop = this.jqxWidget.nativeElement.offsetTop;
        this.window.position({ x: offsetLeft + 50, y: offsetTop + 50 });

        this.window.focus();
    }

    onResizeCheckBox(event: any): void {
        if (event.args.checked) {
            this.window.resizable(true);
        }
        else {
            this.window.resizable(false);
        }
    };

    onDragCheckBox(event: any): void {
        if (event.args.checked) {
            this.window.draggable(true);
        }
        else {
            this.window.draggable(false);
        }
    };

    onShowButton(): void {
        this.window.open();
    };

    onHideButton(): void {
        this.window.close();
    };
}

Summary

jQWidgets UI for Angular provides an easy way to integrate robust UI components into your Angular project. By using either the ng add command or manual setup, you can quickly get started. Once the setup is complete, you can add the desired jQWidgets components and configure them in your Angular components to match your application requirements.

Window API

API Reference of the jQWidgets Window component for Angular: Window API